// *******************************************************************************
// 	this will parse the XML file from datamonster & product a monster file
// 	suitable for ADMP
/**********************************************************************
 *    Copyright Torquil Gault 2005+
 * #       This program is free software; you can redistribute it and/or
 * #       modify it under the terms of the GNU General Public License
 * #       as published by the Free Software Foundation; either version 2
 * #       of the License, or (at your option) any later version.
 * #
 * #       This program is distributed in the hope that it will be useful,
 * #       but WITHOUT ANY WARRANTY; without even the implied warranty of
 * #       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * #       GNU General Public License for more details.
 * #
 * #       You should have received a copy of the GNU General Public License
 * #       along with this program; if not, write to the Free Software
 * #       Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * #
 * #
 * ###############################################################################
 **********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>

#include "ADMPdata.h"
#include "pDBlibrary.h"

int writeAllPlayerData(char *);

char line[2048];
char oline[2048];
char pline[2048];

char *tk[30], *cp, mybuf[100], *cp1, mybuf2[100];

FILE *inf, *nof;

ADMPplayer p[MAX_QKMONSTERS];

ADMPweapon wp;

char *dr_types[] = { "", "+", "-", "adamantine", "bludgeoning", "chaotic", "cold",
		  "epic", "evil", "good", "lawful", "magic", "silver", "slashing", NULL};

int errflag=0;

typedef struct enviroment {
	char id;
	char *name;
} enviroment;

enviroment enviro[] = {
{1, "A chaos-aligned plane"},
{2, "A chaotic-aligned plane"},
{3, "A chaotic evil-aligned plane"},
{4, "A chaotic good-aligned plane"},
{5, "A evil-aligned plane"},
{6, "A good-aligned plane."},
{7, "A lawful-aligned plane"},
{8, "A lawful evil-aligned plane"},
{9, "A lawful good-aligned plane"},
{10, "An evil-aligned plane"},
{11, "Any"},
{12, "Any good-aligned plane"},
{11, "Any(Lacedon: Any aquatic)"},
{13, "Any land and underground"},
{14, "Cold aquatic"},
{15, "Cold desert"},
{16, "Cold forests"},
{17, "Cold hills"},
{18, "Cold marshes"},
{19, "Cold mountains"},
{19, "Cold mountains (Scrag: Cold aquatic)"},
{20, "Cold plains"},
{21, "Elemental Plane of Air"},
{22, "Elemental Plane of Earth"},
{23, "Elemental Plane of Fire"},
{24, "Elemental Plane of Water"},
{25, "Ethereal Plane"},
{26, "Ever-Changing Chaos of Limbo"},
{27, "Plane of Shadow"},
{28, "Positive Energy Plane"},
{29, "Temperate aquatic"},
{30, "Temperate deserts"},
{30, "Temperate forests"},
{30, "Temperate forest(Half-elf: Temperate forests)(Aquatic: Temperate aquatic)(Gray: Temperate mountains)(Wild: Warm forests)(Wood: Temperate forests)"},
{31, "Temperate hills"},
{31, "Temperate hills (Forest gnomes: Temperate forests)"},
{31, "Temperate hills (Merrow: Temperate aquatic)"},
{32, "Temperate marshes"},
{32, "Temperate marshes (Pyro: Warm marshes) (Cryo: Cold marshes)"},
{32, "Temperate marshes(Pyro: Warm marshes) (Cryo: Cold marshes)"},
{33, "Temperate mountains"},
{33, "Temperate mountains (Deep: Underground)"},
{34, "Temperate plains"},
{35, "Underground"},
{36, "Warm aquatic"},
{37, "Warm deserts"},
{38, "Warm forests"},
{39, "Warm hills"},
{40, "Warm marshes"},
{41, "Warm mountains"},
{42, "Warm plains"},
{42, "Warm plains(Deep halfling: Warm hills)(Tallfellow: Temperate forests)"},
{-1, NULL}};


// *******************************************************************************
void eol() {
	int l;
	l = strlen(line);
	while (l > 0) {
// printf("%s\n", &line[l]);
		if (line[l] == '/' && line[l-1] == ' ') {
			line[l-1] = '\0';
			return;
		}
		l--;
	}
}

// *******************************************************************************
void rmStuff() {
	int i;

	for (i=0; i<10; i++) {
		if (wp.c_damage[i] == ')') wp.c_damage[i] = '\0';
		if (wp.c_critical[i] == ')') wp.c_critical[i] = '\0';
	}
	for (i=0; i<30; i++) {
		if (wp.c_description[i] == ')') wp.c_description[i] = ' ';
	}
}

// *******************************************************************************
int myindex(char *str, char fnd) {
	int i=0;

	while (str[i] != '\0') {
		if (str[i] == fnd) {
			return(i);
		}
		i++;
	}
	return(-1);
}

// *******************************************************************************
void dumpnote(char *title) {
	char tline[2048];
	int sp=0;

	strcpy(tline, oline);
	sp=myindex(tline, ' ');
	fprintf(nof, "%s%s|", title, &tline[sp]);
}

// *******************************************************************************
int main(int argc, char **argv) {
	int i=-1, j, k, w;
	int z,a,b;

	if ((inf = fopen(argv[1], "r")) == NULL) {
		printf("unable to open file ...\n");
		exit(0);
	}

	if ((nof = fopen("srdmonster.snt", "w+")) == NULL) {
		printf("unable to open file ...\n");
		exit(0);
	}
	fprintf(nof, "=000547");

	memset(&p[0].c_name[0], '\0', sizeof(ADMPplayer)*MAX_QKMONSTERS);

	while (fgets(line, 2048, inf) != NULL) {
		eol();
		strcpy(oline, line);
		tk[0] = strtok(line, " ");
		tk[1] = strtok(NULL, " ");
//printf("Parsing: %s %s\n", tk[0], tk[1]);
//
		if (strcasecmp(tk[0], "name") == 0) {
			if (i != -1) {
				for (j=0; j<MAX_WEAPONS; j++) {
					if (p[i].w_weapons[j].c_description[0] != '\0' && (p[i].w_weapons[j].i_attackBonus[0] < 0 || p[i].w_weapons[j].i_attackBonus[0] > 100)) {
						printf("Weapon error: %s %d\n", p[i].w_weapons[j].c_description, p[i].w_weapons[j].i_attackBonus[0]);
						errflag = 1;
					}
				}
				if (p[i].i_noAttacks < 0 || p[i].i_noAttacks > 20) { errflag = 1; printf("error = noAttacks\n"); }
				if (p[i].i_hp[HP_MAX] == 0) { errflag = 1; p[i].i_hp[HP_MAX] = 1; printf("error = hp\n"); }
				if (errflag != 0) {
					printf("Possible error with %d - %s\n", i, p[i].c_name);
				}
			}
			errflag = 0;
			i++;
			strncpy(p[i].c_name, &oline[5], 29);
			p[i].c_name[29] = '\0';
			if (i > 0) {
				printf("Parsing: 1 %s %d\n", p[i-1].c_name, p[i-1].i_noAttacks);
			}
printf("Parsing: %s %s\n", p[i].c_name, tk[1]);
			// p[i].i_gridLocation[0] = p[i].i_gridLocation[1] = 
			p[i].i_unconciousAt = -1;
			memset(&wp.c_available, '\0', sizeof(ADMPweapon));
			j = k = w = z = a = b = 0;
			fprintf(nof, "\n+%d|%d|", i, i);
		} else if (strcasecmp(tk[0], "environment") == 0) { // environment /environment 
			dumpnote("Environment:");
printf("Env: %s %s %d\n", p[i].c_name, oline, j);
			for (j=0; enviro[j].id != -1; j++) {
				if (strcasecmp(&oline[12], enviro[j].name) == 0) {
					p[i].c_environment = enviro[j].id;
printf("Env: %s %s %d\n", p[i].c_name, oline, j);
					break;
				}
			}
		} else if (strcasecmp(tk[0], "size") == 0) { // Medium /size 
			p[i].i_size = 3;
			if (strcasecmp(tk[1], "Gargantuan") == 0) p[i].i_size = 7;
			if (strcasecmp(tk[1], "Colossal") == 0) p[i].i_size = 6;
			if (strcasecmp(tk[1], "Huge") == 0) p[i].i_size = 5;
			if (strcasecmp(tk[1], "Large") == 0) p[i].i_size = 4;
			if (strcasecmp(tk[1], "Medium") == 0) p[i].i_size = 3;
			if (strcasecmp(tk[1], "Small") == 0) p[i].i_size = 2;
			if (strcasecmp(tk[1], "Tiny") == 0) p[i].i_size = 1;
		} else if (strcasecmp(tk[0], "hit_dice") == 0) { // 1d8+1 (5 hp) /hit_dice 
			tk[1] = strtok(NULL, " ");
			if ((k = myindex(oline, '(')) != -1) { oline[k] = '\0'; }
			if (oline[k+2] == ' ') { oline[k+2] = '\0'; }
			if (oline[k+3] == ' ') { oline[k+3] = '\0'; }
			if (oline[k+4] == ' ') { oline[k+4] = '\0'; }
			p[i].i_hp[0] = p[i].i_hp[1] = atoi(&oline[k+1]);
			strncpy(p[i].c_hitDice, &oline[9] , 19);
			p[i].c_hitDice[19] = '\0';
			for (k=0; k<19; k++) {
				if (p[i].c_hitDice[k] == '(') {
					p[i].c_hitDice[k-1] = '\0';
					break;
				}
			}
			if (p[i].i_hp[0] > 1000 || p[i].i_hp[0] < 1) { errflag = 1; printf("error = hp-1\n"); }
//printf("HD: %s\n", p[i].c_hitDice);
		} else if (strcasecmp(tk[0], "initiative") == 0) { // +4 /initiative 
			p[i].i_initiative[0] = atoi(tk[1]);
		} else if (strcasecmp(tk[0], "speed") == 0) { // 20 ft. in scale mail (4 squares); base speed 30 ft. /speed 
			p[i].i_speed = atoi(tk[1]);
			if (p[i].i_speed == 0) {
				tk[1] = strtok(NULL, " ");
				p[i].i_speed = atoi(tk[1]);
			}
		} else if (strcasecmp(tk[0], "armor_class") == 0) { // 16 (+4 scale mail +2 heavy shield) touch 10 flat-footed 16 /armor_class 
			p[i].i_armorClass[AC_NORMAL] = atoi(tk[1]);
			if (p[i].i_armorClass[AC_NORMAL] > 100 || p[i].i_armorClass[AC_NORMAL] < 0) { errflag = 1; printf("error = A/C\n"); }
			tk[1] = strtok(NULL, " ");
			tk[0] = tk[1];
			while (tk[1] != NULL) {
				strcpy(oline, &tk[0][0]);
				if (oline[0] == '(') {
					strcpy(oline, &oline[1]);
				}
//printf("AC O=%s 0=%s 1=%s\n", oline, tk[0], tk[1]);
				if (strcasecmp(tk[1], "touch") == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_armorClass[AC_TOUCH] = atoi(tk[1]);
				} else if (strcasecmp(tk[1], "flat-footed") == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_armorClass[AC_FLATFOOTED] = atoi(tk[1]);
				} else if (strcasecmp(tk[1], "size") == 0 || strcasecmp(tk[1], "size)") == 0 || strcasecmp(tk[1], "(size") == 0) {
					p[i].i_armorClassSplit[AC_SECTION_SIZE] = atoi(oline);
				} else if (strcasecmp(tk[1], "dex") == 0 || strcasecmp(tk[1], "dex)") == 0 || strcasecmp(tk[1], "(dex") == 0) {
					p[i].i_armorClassSplit[AC_SECTION_DEX] = atoi(oline);
				} else if (strcasecmp(tk[1], "natural") == 0 || strcasecmp(tk[1], "natural)") == 0 || strcasecmp(tk[1], "(natural") == 0) {
					p[i].i_armorClassSplit[AC_SECTION_NATURAL] = atoi(oline);
				} else if (strcasecmp(tk[1], "shield") == 0 || strcasecmp(tk[1], "shield)") == 0 || strcasecmp(tk[1], "(shield") == 0) {
					p[i].i_armorClassSplit[AC_SECTION_SHIELD] = atoi(oline);
				}
				tk[0] = tk[1];
				tk[1] = strtok(NULL, " ");
			}
		} else if (strcasecmp(tk[0], "base_attack") == 0) { // +1 /base_attack 
			p[i].i_bab[BAB_MELEE][0] = atoi(tk[1]);
		} else if (strcasecmp(tk[0], "grapple") == 0) { // +2 /grapple 
			p[i].i_bab[BAB_GRAPPLE][0] = atoi(tk[1]);
		} else if (strcasecmp(tk[0], "attack") == 0) { // Longsword +2 melee (1d8+1/19-20) or light crossbow +1 ranged (1d8/19-20) /attack 
			strcpy(pline, oline);
		} else if (strcasecmp(tk[0], "full_attack") == 0) { // Longsword +2 melee (1d8+1/19-20) or light crossbow +1 ranged (1d8/19-20) /full_attack 
//printf("W: %s (%s)\n", oline, tk[1]);
			int flag1=0, flag2=0, flag3=0;
			if (strstr(oline, "Multiattack") != NULL || strstr(oline, "secondary") != NULL) {
				strcpy(mybuf, &tk[1][0]);
				strcpy(mybuf2, &tk[1][0]);
				strcpy(oline, pline);
				strcpy(line, pline);
				strcpy(pline, mybuf);
				tk[0] = strtok(line, " ");
				tk[1] = strtok(NULL, " ");
				flag3=1;
			}
//printf("W: %s (%s:%d)\n", oline, pline, flag3);
			int wtype=0, c;
			p[i].i_noAttacks = 1;
			j = k = w = 0;
			mybuf[0] = '\0';
			memset(&wp.c_available, '\0', sizeof(ADMPweapon)); mybuf[0] = '\0';
			wp.i_noAttacks = 1; wp.c_available = 1;
			while (tk[1] != NULL) {
// printf("W: %s\n", tk[1]);
				if (tk[1][0] == '/') {
					break;
				} else if (strcasecmp(tk[1], "melee") == 0) {
					wtype = 0;
				} else if (strcasecmp(tk[1], "ranged") == 0) {
					wtype = 1;
				} else if (tk[1][0] == '(') {		// found (DAM/CRIT)
//					j = myindex(&tk[1][1], ')') - 1; if (j > 29) { j = 29; }
//printf("wp: 0: %s (%d)\n", tk[1], j);
//					strncpy(wp.c_message, &tk[1][1], j);
					if ((cp = strstr(tk[1], "/")) != NULL) {
						*cp = '\0'; cp++;
						strcpy(wp.c_critical, cp);
						strcpy(wp.c_damage, &tk[1][1]);
					} else {
						strcpy(wp.c_critical, "*3");
						strcpy(wp.c_damage, &tk[1][1]);
					}
				} else if (isdigit(tk[1][0]) != 0 || isdigit(tk[1][1]) != 0) {
// printf("wp: 1 %s %d\n", tk[1], flag1);
					if ((tk[1][0] == '+' || tk[1][0] == '-') && strstr(tk[1], "/") == NULL) { // ignore +3/+2
						if (flag3 == 1) {
//printf("wp: 2a %s %s\n", tk[1], pline);
							if ((cp = strstr(pline, "/")) != NULL) {
								*cp = '\0'; cp++; wp.i_attackBonus[0] = atoi(pline);
								j = 1;
								while ((cp1 = strstr(cp, "/")) != NULL) {
									*cp1 = '\0'; cp1++;
									wp.i_attackBonus[j++] = atoi(cp);
									cp = cp1;
								}
								wp.i_attackBonus[j++] = atoi(cp);
								wp.i_noAttacks = 1;
								p[i].i_noAttacks = j;
								strcpy(pline, mybuf2);
							} else {
								wp.i_attackBonus[0] = atoi(tk[1]);
								strcat(mybuf, " "); strcat(mybuf, tk[1]);
							}
						} else {
							if (flag1 == 0) {
								strcpy(mybuf, tk[1]);
								wp.i_magicalBonus = atoi(tk[1]);
								flag1 = 1;
							} else {
								wp.i_attackBonus[0] = atoi(tk[1]);
								strcat(mybuf, " "); strcat(mybuf, tk[1]);
							}
						}
					} else if (tk[1][0] == '+' && (cp = strstr(tk[1], "/")) != NULL) { // +3/+2
// printf("wp: 2 %s %d\n", tk[1], flag1);
						if (flag3 == 1) {
							tk[1] = pline;
							cp = strstr(pline, "/");
//printf("wp: 2b %s %s\n", tk[1], cp);
						}
						*cp = '\0'; cp++; wp.i_attackBonus[0] = atoi(tk[1]);
						j = 1;
						while ((cp1 = strstr(cp, "/")) != NULL) {
							*cp1 = '\0'; cp1++;
							wp.i_attackBonus[j++] = atoi(cp);
							cp = cp1;
						}
						wp.i_attackBonus[j++] = atoi(cp);
						wp.i_noAttacks = j;
					} else {
// printf("wp: 3 %s %d\n", tk[1], flag1);
						if (flag3 == 1) {
							tk[1] = pline;
							if ((cp = strstr(pline, "/")) != NULL) {
//printf("wp: 2c %s %s\n", tk[1], cp);
								*cp = '\0'; cp++; wp.i_attackBonus[0] = atoi(pline);
								j = 1;
								while ((cp1 = strstr(cp, "/")) != NULL) {
									*cp1 = '\0'; cp1++;
									wp.i_attackBonus[j++] = atoi(cp);
									cp = cp1;
								}
								wp.i_attackBonus[j++] = atoi(cp);
								wp.i_noAttacks = j;
							} else {
								wp.i_attackBonus[0] = atoi(tk[1]);
								strcat(mybuf, " "); strcat(mybuf, tk[1]);
							}
						} else {
							if (flag1 == 0) {
								wp.i_noAttacks = atoi(tk[1]);
								strcat(mybuf, tk[1]);
								if (flag2 == 1) { 
									p[i].i_noAttacks += wp.i_noAttacks; 
								} else {
									if (p[i].i_noAttacks < wp.i_noAttacks) {
										p[i].i_noAttacks = wp.i_noAttacks;
									}
								}
								flag1 = 1;
							} else {
								wp.i_attackBonus[0] = atoi(tk[1]);
							}
						}
					}
				} else if (strcasecmp(tk[1], "or") == 0) {
					flag1 = 0; flag2 = 0;
					strncpy(wp.c_description, mybuf, 29); wp.c_description[29] = '\0';
					rmStuff();
//					if (wp.i_attackBonus[0] < p[i].i_bab[BAB_MELEE][0]) { wp.i_attackBonus[0] = p[i].i_bab[BAB_MELEE][0]; }
					memcpy(&p[i].w_weapons[w++].c_available, &wp.c_available, sizeof(ADMPweapon));
					memset(&wp.c_available, '\0', sizeof(ADMPweapon)); mybuf[0] = '\0';
					wp.i_noAttacks = 1; wp.c_available = 1;
				} else if (strcasecmp(tk[1], "and") == 0) {
					flag1 = 0; flag2 = 1;
					strncpy(wp.c_description, mybuf, 29); wp.c_description[29] = '\0';
					rmStuff();
//					if (wp.i_attackBonus[0] < p[i].i_bab[BAB_MELEE][0]) { wp.i_attackBonus[0] = p[i].i_bab[BAB_MELEE][0]; }
					memcpy(&p[i].w_weapons[w++].c_available, &wp.c_available, sizeof(ADMPweapon));
					memset(&wp.c_available, '\0', sizeof(ADMPweapon)); mybuf[0] = '\0';
					wp.i_noAttacks = 1; wp.c_available = 1;
				} else {
					if (mybuf[0] != '\0') {
						strcat(mybuf, " ");
					}
					strcat(mybuf, tk[1]);
					flag1 = 1;
				}
				tk[3] = tk[1];
				tk[1] = strtok(NULL, " ");
			}
			strncpy(wp.c_description, mybuf, 29); wp.c_description[29] = '\0';
			rmStuff();
//			if (wp.i_attackBonus[0] < p[i].i_bab[BAB_MELEE][0]) { wp.i_attackBonus[0] = p[i].i_bab[BAB_MELEE][0]; }
			if (wtype == 0 && p[i].w_weapons[w].c_description[0] == '\0') {
				memcpy(&p[i].w_weapons[w].c_available, &wp.c_available, sizeof(ADMPweapon));
			}
			if (wtype == 1 && p[i].w_weapons[6].c_description[0] == '\0') {
				memcpy(&p[i].w_weapons[6].c_available, &wp.c_available, sizeof(ADMPweapon));
			}
//			if (flag2 == 1) { p[i].i_noAttacks += wp.i_noAttacks; }
		} else if (strcasecmp(tk[0], "space") == 0) { // 5 ft. /space 
			p[i].i_space = atoi(tk[1]);
		} else if (strcasecmp(tk[0], "reach") == 0) { // 5 ft. /reach 
			p[i].i_reach = atoi(tk[1]);
		} else if (strcasecmp(tk[0], "skills") == 0) { // skills
			dumpnote("Skills:");
			while (tk[1] != NULL) {
				if (strcasecmp("search", tk[1]) == 0) {
					tk[1] = strtok(NULL, " "); p[i].i_skills[SKILL_SEARCH] = atoi(tk[1]);
				} else if (strcasecmp("spot", tk[1]) == 0) {
					tk[1] = strtok(NULL, " "); p[i].i_skills[SKILL_SPOT] = atoi(tk[1]);
				} else if (strcasecmp("locks", tk[1]) == 0) {
					tk[1] = strtok(NULL, " "); p[i].i_skills[SKILL_OPENLOCKS] = atoi(tk[1]);
				} else if (strcasecmp("silently", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_skills[SKILL_MOVESILENTLY] = atoi(tk[1]);
				} else if (strcasecmp("listen", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_skills[SKILL_LISTEN] = atoi(tk[1]);
				} else if (strcasecmp("hand", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_skills[SKILL_SOH] = atoi(tk[1]);
				} else if (strcasecmp("hide", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_skills[SKILL_HIDE] = atoi(tk[1]);
				} else if (strcasecmp("concentration", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_skills[SKILL_CONCENTRATION] = atoi(tk[1]);
				} 
				tk[1] = strtok(NULL, " ");
			}
		} else if (strcasecmp(tk[0], "special_attacks") == 0) { // Daylight /special_attacks 
			dumpnote("Special Attacks:");
		} else if (strcasecmp(tk[0], "feats") == 0) { // Daylight /special_attacks 
			dumpnote("Feats:");
		} else if (strcasecmp(tk[0], "organization") == 0) { // Daylight /special_attacks 
			dumpnote("Organization:");
		} else if (strcasecmp(tk[0], "treasure") == 0) { // Daylight /special_attacks 
			dumpnote("Treasure:");
		} else if (strcasecmp(tk[0], "saves") == 0) { // Fort +3 Ref +0 Will +0 /saves 
			while (tk[1] != NULL) {
				if (strcasecmp("fort", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_savingThrows[SAVE_FORTITUDE] = atoi(tk[1]);
				} else if (strcasecmp("ref", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_savingThrows[SAVE_REFLEX] = atoi(tk[1]);
				} else if (strcasecmp("will", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_savingThrows[SAVE_WISDOM] = atoi(tk[1]);
				}
				tk[1] = strtok(NULL, " ");
			}
		} else if (strcasecmp(tk[0], "abilities") == 0) { // Str 13 Dex 11 Con 12 Int 10 Wis 11 Cha 10 /abilities 
			dumpnote("Abilities:");
			while (tk[1] != NULL) {
				if (strcasecmp("str", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_abilityStats[0][ABILITY_STR] = p[i].i_abilityStats[1][ABILITY_STR] = atoi(tk[1]);
				} else if (strcasecmp("dex", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_abilityStats[0][ABILITY_DEX] = p[i].i_abilityStats[1][ABILITY_DEX] = atoi(tk[1]);
				} else if (strcasecmp("con", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_abilityStats[0][ABILITY_CON] = p[i].i_abilityStats[1][ABILITY_CON] = atoi(tk[1]);
				} else if (strcasecmp("int", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_abilityStats[0][ABILITY_INT] = p[i].i_abilityStats[1][ABILITY_INT] = atoi(tk[1]);
				} else if (strcasecmp("wis", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_abilityStats[0][ABILITY_WIS] = p[i].i_abilityStats[1][ABILITY_WIS] = atoi(tk[1]);
				} else if (strcasecmp("cha", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_abilityStats[0][ABILITY_CHA] = p[i].i_abilityStats[1][ABILITY_CHA] = atoi(tk[1]);
				}
				tk[1] = strtok(NULL, " ");
			}
		} else if (strcasecmp("challenge_rating", tk[0]) == 0) { // 1/2 /challenge_rating 
			if (strcasecmp(tk[1], "1/10") == 0) {
				p[i].f_challengeRating = 0.1;
			} else if (strcasecmp(tk[1], "1/2") == 0) {
				p[i].f_challengeRating = 0.5;
			} else if (strcasecmp(tk[1], "1/3") == 0) {
				p[i].f_challengeRating = 0.33;
			} else if (strcasecmp(tk[1], "1/4") == 0) {
				p[i].f_challengeRating = 0.25;
			} else if (strcasecmp(tk[1], "1/6") == 0) {
				p[i].f_challengeRating = 0.166;
			} else if (strcasecmp(tk[1], "1/8") == 0) {
				p[i].f_challengeRating = 0.125;
			} else {
				p[i].f_challengeRating = (float )atoi(tk[1]);
			}
		} else if (strcasecmp(tk[0], "special_qualities") == 0) { // 
			dumpnote("Special Qualities:");
			tk[0] = tk[1];
			tk[1] = strtok(NULL, " ");
// printf("sQ: %s %s\n", tk[1], tk[0]);
			while (tk[1] != NULL) {
// printf("sQ: %s %s\n", tk[1], tk[0]);
				if (strcasecmp("regeneration", tk[1]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_regeneration = atoi(tk[1]);
// printf("Regen: %d\n", p[i].i_regeneration);
//					tk[0] = strtok(NULL, " ");
//					tk[1] = strtok(NULL, " ");
				} else if (strcasecmp("resistance", tk[1]) == 0 && strcasecmp("spell", tk[0]) == 0) {
					tk[1] = strtok(NULL, " ");
					p[i].i_spellResistance = atoi(tk[1]);
					tk[0] = strtok(NULL, " ");
					tk[1] = strtok(NULL, " ");
				} else if (strcasecmp("reduction", tk[1]) == 0 && strcasecmp("damage", tk[0]) == 0) {
					j = 0;
					tk[1] = strtok(NULL, " ");
					strcpy(mybuf, tk[1]);
					if (mybuf[1] == '/') { mybuf[1] = '\0'; j = 2; }
					if (mybuf[2] == '/') { mybuf[2] = '\0'; j = 3; }
					if (mybuf[3] == '/') { mybuf[3] = '\0'; j = 4; }
					p[i].i_damageReduction[0] = p[i].i_damageReduction[2] = p[i].i_damageReduction[3] = 0;
					p[i].i_damageReduction[1] = atoi(mybuf);
//printf("DR: %s %d %s\n", p[i].c_name, j, &mybuf[j]);
					if (mybuf[j] > '9' || mybuf[j] < '0') {
						for (k=1; dr_types[k] != NULL; k++) {
							if (strcasecmp(&mybuf[j], dr_types[k]) == 0) {
//printf("DR: %s %s %s %d\n", p[i].c_name, &mybuf[j], dr_types[k], k);
								p[i].i_damageReduction[0] = k;
								break;
							}
						}
					} else {
						p[i].i_damageReduction[2] = atoi(&mybuf[j]);
					}
//printf("DR: %d %d/%d\n", p[i].i_damageReduction[0], p[i].i_damageReduction[1], p[i].i_damageReduction[2]);
				}
				tk[0] = tk[1];
				tk[1] = strtok(NULL, " ");
			}
		}
	}

		// some final cleanups etc .....
	k=0;
	for (i = 0; i < MAX_QKMONSTERS; i++) {
		if (p[i].c_name[0] == '\0' && p[i].i_hp[HP_MAX] == 0) {
			sprintf(p[i].c_name, "-- empty slot %d", k++);
		} else {
			for (j=0; j<MAX_WEAPONS; j++) {
				if (p[i].w_weapons[j].c_description[0] != '\0') {
					if (p[i].w_weapons[j].i_noAttacks == 0) { p[i].w_weapons[j].i_noAttacks = 1; }
					if (p[i].w_weapons[j].c_critical[0] == '\0') {
						strcpy(p[i].w_weapons[j].c_critical, "*3");
					}
				}
				p[i].i_whomAttacked[j][0] = -1;
				if (p[i].i_hp[HP_MAX] == 0) { p[i].i_hp[HP_MAX] = p[i].i_hp[HP_CUR] = 1; }
			}
			if (strcmp(p[i].c_name, "Ettin") == 0) {
				p[i].i_noAttacks = 4;
				strcpy(&p[i].w_weapons[0].c_description[0], "Morningstar +12/+7");
				memcpy(&p[i].w_weapons[1].c_available, &p[i].w_weapons[0].c_available, sizeof(ADMPweapon));
			} else if (strcmp(p[i].c_name, "Satyr") == 0) {
				p[i].i_noAttacks = 2;
			} else if (strcmp(p[i].c_name, "Troglodyte") == 0) {
				p[i].i_noAttacks = 3;
			} else if (strcmp(p[i].c_name, "Badger") == 0) {
				p[i].i_noAttacks = 2;
			} else if (strcmp(p[i].c_name, "Cat") == 0) {
				p[i].i_noAttacks = 3;
			} else if (strcmp(p[i].c_name, "Eagle") == 0) {
				p[i].i_noAttacks = 3;
			} else if (strcmp(p[i].c_name, "Horse Heavy") == 0) {
				p[i].i_noAttacks = 3;
			} else if (strcmp(p[i].c_name, "Horse Light") == 0) {
				p[i].i_noAttacks = 3;
			} else if (strcmp(p[i].c_name, "Warhorse Heavy") == 0) {
				p[i].i_noAttacks = 3;
			} else if (strcmp(p[i].c_name, "Warhorse Light") == 0) {
				p[i].i_noAttacks = 3;
			} else if (strcmp(p[i].c_name, "Grick") == 0) {
				p[i].i_noAttacks = 5;
			}

		}
	}
	fclose(inf);

	for (i = 0; i < MAX_QKMONSTERS; i++) {
		if (strncmp(p[i].c_name, "-- empty slot", 13) == 0) {
			break;
		}
	}
#include "stdmonsters.h"

	if ((inf = fopen("qkmonst.dat", "w")) != NULL) {
		fwrite(&p[0].c_name[0], sizeof(ADMPplayer) * MAX_QKMONSTERS, 1, inf);
		fclose(inf);
	} else {
		printf("unable to open file %d\n", i);
	}

	writeAllPlayerData("srdmonster");

	fclose(nof);
}

/********************************************************************************/
int pi_id, wi_id;

int writePlayerWeaponData() {
FILE *wfile;
ADMPweapon *wp;

	wfile = pdbFilePointer;
	wp = (ADMPweapon *)pdbDataPointer;

//	pdbPutInt(wfile, players[pid].i_id);
	pdbPutInt(wfile, pi_id);
	pdbPutInt(wfile, wi_id);
	pdbPutInt(wfile, wp->c_available);
	pdbPutString(wfile, &wp->c_description[0]);
	pdbPutInt(wfile, wp->i_attackBonus[0]);
	pdbPutInt(wfile, wp->i_attackBonus[1]);
	pdbPutInt(wfile, wp->i_attackBonus[2]);
	pdbPutInt(wfile, wp->i_attackBonus[3]);
	pdbPutString(wfile, wp->c_damage);
	pdbPutString(wfile, wp->c_critical);
	pdbPutInt(wfile, wp->i_magicalBonus);
	pdbPutInt(wfile, wp->i_range);
	pdbPutInt(wfile, wp->i_reach);
	pdbPutInt(wfile, wp->i_noAttacks);
	pdbPutString(wfile, wp->c_message);
	pdbPutString(wfile, wp->c_description);
	pdbPutString(wfile, wp->c_damage);
	pdbPutString(wfile, wp->c_critical);
	pdbPutInt(wfile, wp->c_attackType);

	return 0;
}

/********************************************************************************/
int writePlayerData() {
FILE *ofile;
ADMPplayer *pd;

	ofile = pdbFilePointer;
	pd = (ADMPplayer *)pdbDataPointer;

	pdbPutInt(ofile, pi_id);
//	pdbPutInt(ofile, pd->i_id);

	pdbPutString(ofile, pd->c_name);
	pdbPutInt(ofile, pd->i_race);
	pdbPutInt(ofile, pd->i_alignment);
	pdbPutInt(ofile, pd->i_classes[0]);
	pdbPutInt(ofile, pd->i_classes[1]);
	pdbPutInt(ofile, pd->i_classes[2]);
	pdbPutInt(ofile, pd->i_classes[3]);
	pdbPutInt(ofile, pd->i_levels[0]);
	pdbPutInt(ofile, pd->i_levels[1]);
	pdbPutInt(ofile, pd->i_levels[2]);
	pdbPutInt(ofile, pd->i_levels[3]);
	pdbPutInt(ofile, pd->i_hp[HP_MAX]);
	pdbPutInt(ofile, pd->i_hp[HP_CUR]);
	pdbPutInt(ofile, pd->i_hp[HP_NL]);
	pdbPutInt(ofile, pd->i_hp[HP_TMP]);
	pdbPutInt(ofile, pd->i_bleeding);
	pdbPutInt(ofile, pd->i_disabledAt);
	pdbPutInt(ofile, pd->i_unconciousAt);
	pdbPutInt(ofile, pd->i_savingThrows[SAVE_FORTITUDE]);
	pdbPutInt(ofile, pd->i_savingThrows[SAVE_REFLEX]);
	pdbPutInt(ofile, pd->i_savingThrows[SAVE_WISDOM]);
	pdbPutInt(ofile, pd->i_armorClass[AC_NORMAL]);
	pdbPutInt(ofile, pd->i_armorClass[AC_TOUCH]);
	pdbPutInt(ofile, pd->i_armorClass[AC_FLATFOOTED]);
	pdbPutInt(ofile, pd->i_armorClassSplit[AC_SECTION_DEX]);
	pdbPutInt(ofile, pd->i_armorClassSplit[AC_SECTION_SIZE]);
	pdbPutInt(ofile, pd->i_armorClassSplit[AC_SECTION_DEFLECTION]);
	pdbPutInt(ofile, pd->i_armorClassSplit[AC_SECTION_NATURAL]);
	pdbPutInt(ofile, pd->i_armorClassSplit[AC_SECTION_ARMOR]);
	pdbPutInt(ofile, pd->i_armorClassSplit[AC_SECTION_SHIELD]);
	pdbPutInt(ofile, pd->i_bab[BAB_MELEE][0]);
	pdbPutInt(ofile, pd->i_bab[BAB_RANGED][0]);
	pdbPutInt(ofile, pd->i_bab[BAB_GRAPPLE][0]);
	pdbPutInt(ofile, pd->i_bab[BAB_MELEE][1]);
	pdbPutInt(ofile, pd->i_bab[BAB_RANGED][1]);
	pdbPutInt(ofile, pd->i_bab[BAB_GRAPPLE][1]);
	pdbPutInt(ofile, pd->i_bab[BAB_MELEE][2]);
	pdbPutInt(ofile, pd->i_bab[BAB_RANGED][2]);
	pdbPutInt(ofile, pd->i_bab[BAB_GRAPPLE][2]);
	pdbPutInt(ofile, pd->i_initiative[0]);
	pdbPutInt(ofile, pd->i_initiative[1]);
	pdbPutInt(ofile, pd->i_speed);
	pdbPutInt(ofile, pd->i_inactive);
	pdbPutInt(ofile, pd->i_stun);
	pdbPutInt(ofile, pd->i_noAttacks);

	pdbPutFloat(ofile, pd->f_challengeRating);
	pdbPutInt(ofile, pd->i_d20Rolls[0]);
	pdbPutInt(ofile, pd->i_d20Rolls[1]);
	pdbPutInt(ofile, pd->i_d20Rolls[2]);
	pdbPutInt(ofile, pd->i_d20Rolls[3]);
	pdbPutInt(ofile, pd->i_d20Rolls[4]);
	pdbPutInt(ofile, pd->i_d20Rolls[5]);
	pdbPutInt(ofile, pd->i_d20Rolls[6]);
	pdbPutInt(ofile, pd->i_spellDC[0]);
	pdbPutInt(ofile, pd->i_spellDC[1]);
	pdbPutInt(ofile, pd->i_spellDC[2]);
	pdbPutInt(ofile, pd->i_spellDC[3]);
	pdbPutInt(ofile, pd->i_spellDC[4]);
	pdbPutInt(ofile, pd->i_spellDC[5]);
	pdbPutInt(ofile, pd->i_spellDC[6]);
	pdbPutInt(ofile, pd->i_spellFailure);
	pdbPutInt(ofile, pd->i_abilityStats[0][0]);
	pdbPutInt(ofile, pd->i_abilityStats[1][0]);
	pdbPutInt(ofile, pd->i_abilityStats[0][1]);
	pdbPutInt(ofile, pd->i_abilityStats[1][1]);
	pdbPutInt(ofile, pd->i_abilityStats[0][2]);
	pdbPutInt(ofile, pd->i_abilityStats[1][2]);
	pdbPutInt(ofile, pd->i_abilityStats[0][3]);
	pdbPutInt(ofile, pd->i_abilityStats[1][3]);
	pdbPutInt(ofile, pd->i_abilityStats[0][4]);
	pdbPutInt(ofile, pd->i_abilityStats[1][4]);
	pdbPutInt(ofile, pd->i_abilityStats[0][5]);
	pdbPutInt(ofile, pd->i_abilityStats[1][5]);
	pdbPutInt(ofile, pd->i_skills[SKILL_SEARCH]);
	pdbPutInt(ofile, pd->i_skills[SKILL_SOH]);
	pdbPutInt(ofile, pd->i_skills[SKILL_SPOT]);
	pdbPutInt(ofile, pd->i_skills[SKILL_OPENLOCKS]);
	pdbPutInt(ofile, pd->i_skills[SKILL_MOVESILENTLY]);
	pdbPutInt(ofile, pd->i_skills[SKILL_LISTEN]);
	pdbPutInt(ofile, pd->i_skills[SKILL_HIDE]);
	pdbPutInt(ofile, pd->i_skills[SKILL_CONCENTRATION]);
	pdbPutInt(ofile, pd->i_spellResistance);
	pdbPutInt(ofile, pd->i_damageReduction[0]);
	pdbPutInt(ofile, pd->i_damageReduction[1]);
	pdbPutInt(ofile, pd->i_damageReduction[2]);
	pdbPutInt(ofile, pd->i_size);
	pdbPutInt(ofile, pd->i_xp[MAX]);
	pdbPutInt(ofile, pd->i_xp[TMP]);
	pdbPutInt(ofile, pd->i_inGroup);
	pdbPutString(ofile, pd->c_hitDice);
	pdbPutFloat(ofile, pd->flags.f_isStabilised);
	pdbPutFloat(ofile, pd->flags.f_disabled);
	pdbPutFloat(ofile, pd->flags.f_ignoreCriticals);
	pdbPutFloat(ofile, pd->flags.f_autoStablise);
	pdbPutFloat(ofile, pd->flags.f_evasion);

	pdbPutInt(ofile, pd->spellsAvailable.i_maxLevel0);
	pdbPutInt(ofile, pd->spellsAvailable.i_maxLevel1);
	pdbPutInt(ofile, pd->spellsAvailable.i_maxLevel2);
	pdbPutInt(ofile, pd->spellsAvailable.i_maxLevel3);
	pdbPutInt(ofile, pd->spellsAvailable.i_maxLevel4);
	pdbPutInt(ofile, pd->spellsAvailable.i_maxLevel5);
	pdbPutInt(ofile, pd->spellsAvailable.i_maxLevel6);
	pdbPutInt(ofile, pd->spellsAvailable.i_maxLevel7);
	pdbPutInt(ofile, pd->spellsAvailable.i_maxLevel8);
	pdbPutInt(ofile, pd->spellsAvailable.i_maxLevel9);
	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel0);
	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel1);
	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel2);
	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel3);
	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel4);
	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel5);
	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel6);
	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel7);
	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel8);
	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel9);

	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel9);	// dummy fields
	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel9);	// dummy fields
	pdbPutInt(ofile, pd->spellsAvailable.i_curLevel9);	// dummy fields
	pdbPutInt(ofile, pd->i_regeneration);

	return 0;
}

/********************************************************************************/
int writeAllPlayerData(char *fx) {
int i, w;
char of[256], wf[256];

	sprintf(of, "%s.std", fx);
	sprintf(wf, "%s.swp", fx);

	pdbClearFile(of);
	pdbClearFile(wf);

	for (i=0; i<MAX_QKMONSTERS; i++) {
		if (p[i].c_name[0] != '\0' && p[i].i_hp[HP_MAX] > 0) {
			pi_id = i;
			pdbAddRecord(of, writePlayerData, (void *)p[i].c_name);
			for (w=0; w<MAX_WEAPONS; w++) {
				if (p[i].w_weapons[w].c_description[0] != '\0' && p[i].w_weapons[w].c_damage[0] != '\0') {
					wi_id = w;
					pdbAddRecord(wf, writePlayerWeaponData, (void *)&p[i].w_weapons[w]);
				}
			}
		}
	}

	return 0;
}
