/**********************************************************************
 *    Copyright Torquil Gault 2005+
 * #       This program is free software; you can redistribute it and/or
 * #       modify it under the terms of the GNU General Public License
 * #       as published by the Free Software Foundation; either version 2
 * #       of the License, or (at your option) any later version.
 * #
 * #       This program is distributed in the hope that it will be useful,
 * #       but WITHOUT ANY WARRANTY; without even the implied warranty of
 * #       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * #       GNU General Public License for more details.
 * #
 * #       You should have received a copy of the GNU General Public License
 * #       along with this program; if not, write to the Free Software
 * #       Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * #
 * #
 * ###############################################################################
 **********************************************************************/
#include <stdio.h>
#include <fcntl.h>

#include "ADMPdata.h"

// ****************************************************************************
ADMPweapon stdweapons[] = {
{0, "Axe,orc", {0,0,0,0}, 1, 0, "1d8", "x3", 5, 0, 0, 0, 'S', 0, ""},
{0, "Axe,throwing", {0,0,0,0}, 1, 0, "1d6", "x2", 10, 0, 0, 0, 'S', 0, ""},
{0, "Battleaxe", {0,0,0,0}, 1, 0, "1d8", "x3", 5, 0, 0, 0, 'S', 0, ""},
{0, "Bolas", {0,0,0,0}, 1, 0, "1d4", "x2", 10, 0, 0, 0, 'B', 0, ""},
{0, "Chain,spiked", {0,0,0,0}, 1, 0, "2d4", "x2", 5, 0, 0, 0, 'P', 0, ""},
{0, "Club", {0,0,0,0}, 1, 0, "1d6", "x2", 10, 0, 0, 0, 'B', 0, ""},
{0, "Dagger", {0,0,0,0}, 1, 0, "1d4", "19-20/*2", 10, 0, 0, 0, 'P', 0, ""},
{0, "Dagger,punching", {0,0,0,0}, 1, 0, "1d4", "x3", 5, 0, 0, 0, 'P', 0, ""},
{0, "Dart", {0,0,0,0}, 1, 0, "1d3", "1d4", 0, 0, 0, 0, '1', 0, ""},
{0, "Falchion", {0,0,0,0}, 1, 0, "2d4", "18-20/*2", 5, 0, 0, 0, 'S', 0, ""},
{0, "Flail", {0,0,0,0}, 1, 0, "1d8", "x2", 5, 0, 0, 0, 'B', 0, ""},
{0, "Flail,dire", {0,0,0,0}, 1, 0, "1d8", "x2", 5, 0, 0, 0, 'B', 0, ""},
{0, "Flail,heavy", {0,0,0,0}, 1, 0, "1d10", "19-20/*2", 5, 0, 0, 0, 'B', 0, ""},
{0, "Gauntlet", {0,0,0,0}, 1, 0, "1d3", "x2", 5, 0, 0, 0, 'B', 0, ""},
{0, "Gauntlet,spiked", {0,0,0,0}, 1, 0, "1d4", "x2", 5, 0, 0, 0, 'P', 0, ""},
{0, "Glaive", {0,0,0,0}, 1, 0, "1d10", "x3", 5, 0, 0, 0, 'S', 0, ""},
{0, "Greataxe", {0,0,0,0}, 1, 0, "1d12", "x3", 5, 0, 0, 0, 'S', 0, ""},
{0, "Greatclub", {0,0,0,0}, 1, 0, "1d10", "x2", 5, 0, 0, 0, 'B', 0, ""},
{0, "Greatsword", {0,0,0,0}, 1, 0, "2d6", "19-20/*2", 5, 0, 0, 0, 'S', 0, ""},
{0, "Guisarme", {0,0,0,0}, 1, 0, "2d4", "x3", 5, 0, 0, 0, 'S', 0, ""},
{0, "Halberd", {0,0,0,0}, 1, 0, "1d10", "x3", 5, 0, 0, 0, 'P', 0, ""},
{0, "Hammer,gnome", {0,0,0,0}, 1, 0, "1d6", "x4", 5, 0, 0, 0, 'B', 0, ""},
{0, "Hammer,light", {0,0,0,0}, 1, 0, "1d4", "x2", 20, 0, 0, 0, 'B', 0, ""},
{0, "Handaxe", {0,0,0,0}, 1, 0, "1d6", "x3", 5, 0, 0, 0, 'S', 0, ""},
{0, "Kama", {0,0,0,0}, 1, 0, "1d6", "x2", 5, 0, 0, 0, 'S', 0, ""},
{0, "Kukri", {0,0,0,0}, 1, 0, "1d4", "18-20/*2", 5, 0, 0, 0, 'S', 0, ""},
{0, "Lance", {0,0,0,0}, 1, 0, "1d8", "x3", 5, 0, 0, 0, 'P', 0, ""},
{0, "Longspear", {0,0,0,0}, 1, 0, "1d8", "x3", 5, 0, 0, 0, 'P', 0, ""},
{0, "Longsword", {0,0,0,0}, 1, 0, "1d8", "19-20/*2", 5, 0, 0, 0, 'S', 0, ""},
{0, "Mace,heavy", {0,0,0,0}, 1, 0, "1d8", "x2", 5, 0, 0, 0, 'B', 0, ""},
{0, "Mace,light", {0,0,0,0}, 1, 0, "1d6", "x2", 5, 0, 0, 0, 'B', 0, ""},
{0, "Morningstar", {0,0,0,0}, 1, 0, "1d8", "x2", 5, 0, 0, 0, 'B', 0, ""},
{0, "Net", {0,0,0,0}, 1, 0, "", "", 0, 0, 0, 0, 'G', 0, ""},
{0, "Nunchaku", {0,0,0,0}, 1, 0, "1d6", "x2", 5, 0, 0, 0, 'B', 0, ""},
{0, "Pick,heavy", {0,0,0,0}, 1, 0, "1d6", "x4", 5, 0, 0, 0, 'P', 0, ""},
{0, "Pick,light", {0,0,0,0}, 1, 0, "1d4", "x4", 5, 0, 0, 0, 'P', 0, ""},
{0, "Quarterstaff", {0,0,0,0}, 1, 0, "1d6", "x2", 5, 0, 0, 0, 'B', 0, ""},
{0, "Ranseur", {0,0,0,0}, 1, 0, "2d4", "x3", 5, 0, 0, 0, 'P', 0, ""},
{0, "Rapier", {0,0,0,0}, 1, 0, "1d6", "18-20/*2", 5, 0, 0, 0, 'P', 0, ""},
{0, "Sai", {0,0,0,0}, 1, 0, "1d4", "x2", 10, 0, 0, 0, 'B', 0, ""},
{0, "Sap", {0,0,0,0}, 1, 0, "1d6", "x2", 5, 0, 0, 0, 'B', 0, ""},
{0, "Scimitar", {0,0,0,0}, 1, 0, "1d6", "18-20/*2", 5, 0, 0, 0, 'S', 0, ""},
{0, "Scythe", {0,0,0,0}, 1, 0, "2d4", "x4", 5, 0, 0, 0, 'P', 0, ""},
{0, "Shortspear", {0,0,0,0}, 1, 0, "1d6", "x2", 20, 0, 0, 0, 'P', 0, ""},
{0, "Shuriken", {0,0,0,0}, 1, 0, "1", "1d2", 0, 0, 0, 0, 'P', 0, ""},
{0, "Siangham", {0,0,0,0}, 1, 0, "1d6", "x2", 5, 0, 0, 0, 'P', 0, ""},
{0, "Sickle", {0,0,0,0}, 1, 0, "1d6", "x2", 5, 0, 0, 0, 'S', 0, ""},
{0, "Sword,bastard", {0,0,0,0}, 1, 0, "1d10", "19-20/*2", 5, 0, 0, 0, 'S', 0, ""},
{0, "Sword,short", {0,0,0,0}, 1, 0, "1d6", "19-20/*2", 5, 0, 0, 0, 'P', 0, ""},
{0, "Sword,two-bladed", {0,0,0,0}, 1, 0, "1d8", "19-20/*2", 5, 0, 0, 0, 'S', 0, ""},
{0, "Trident", {0,0,0,0}, 1, 0, "1d8", "x2", 10, 0, 0, 0, 'P', 0, ""},
{0, "Unarmed strike", {0,0,0,0}, 1, 0, "1d3", "x2", 5, 0, 0, 0, 'B', 0, ""},
{0, "Urgrosh,dwarven", {0,0,0,0}, 1, 0, "1d8", "x3", 5, 0, 0, 0, 'S', 0, ""},
{0, "Waraxe,dwarven", {0,0,0,0}, 1, 0, "1d10", "x3", 5, 0, 0, 0, 'S', 0, ""},
{0, "Warhammer", {0,0,0,0}, 1, 0, "1d8", "x3", 5, 0, 0, 0, 'B', 0, ""},
{0, "Whip", {0,0,0,0}, 1, 0, "1d3", "x2", 15, 0, 0, 0, 'S', 0, ""},
{0, "Crossbow,heavy", {0,0,0,0}, 1, 0, "1d10", "19-20/*2", 120, 0, 0, 0, 'P', 1, ""},
{0, "Crossbow,light", {0,0,0,0}, 1, 0, "1d8", "19-20/*2", 80, 0, 0, 0, 'P', 1, ""},
{0, "Crossbow,repeat", {0,0,0,0}, 1, 0, "1d8", "1d10", 19, 0, 0, 0, 'P', 1, ""},
{0, "Javelin", {0,0,0,0}, 1, 0, "1d6", "x2", 30, 0, 0, 0, 'P', 1, ""},
{0, "Longbow", {0,0,0,0}, 1, 0, "1d8", "x3", 100, 0, 0, 0, 'P', 1, ""},
{0, "Longbow,comp", {0,0,0,0}, 1, 0, "1d8", "x3", 110, 0, 0, 0, 'P', 1, ""},
{0, "Shortbow", {0,0,0,0}, 1, 0, "1d6", "x3", 60, 0, 0, 0, 'P', 1, ""},
{0, "Shortbow,comp", {0,0,0,0}, 1, 0, "1d6", "x3", 70, 0, 0, 0, 'P', 1, ""},
{0, "Sling", {0,0,0,0}, 1, 0, "1d4", "x2", 50, 0, 0, 0, 'B', 1, ""},
{0, "Spear", {0,0,0,0}, 1, 0, "1d8", "x3", 20, 0, 0, 0, 'P', 1, ""}};

// ****************************************************************************
int main() {
FILE *fp;
int i;

	if ((fp = fopen("weapon.dat", "w")) != NULL) {
		fwrite(&stdweapons[0].c_available, sizeof(ADMPweapon) * MAX_STDWEAPONS, 1, fp);
		fclose(fp);
	}
	if ((fp = fopen("stdweapon.wpd", "w")) != NULL) {
		fprintf(fp, "=%6.6d\n", MAX_STDWEAPONS);
		for (i=0; i<MAX_STDWEAPONS; i++) {
			fprintf(fp, "+%d|%d|0|%d|%s|0|0|0|0|%s|%s|%d|%d|%d|%d|%s|%d|\n", i, i, stdweapons[i].c_available, stdweapons[i].c_description,
		  stdweapons[i].c_damage, stdweapons[i].c_critical, stdweapons[i].i_magicalBonus, stdweapons[i].i_range,
		  stdweapons[i].i_reach, stdweapons[i].i_noAttacks,  stdweapons[i].c_message, stdweapons[i].c_attackType);
		}
		fclose(fp);
	}
}
